/* prints standard input to standard output, one word per line */

#include <stdio.h>
#include <ctype.h>

#define MAXLINE 1000

enum { IN, OUT };

int main(void) {
     char buf[MAXLINE];
     int state = OUT;
     int c;

     while ((c=getchar()) != EOF) {
	  if (state == OUT) {
	       if (!isspace(c)) {
		    putchar(c);
		    state = IN;
	       }
	  } else if (state == IN) {
	       if (isspace(c)) {
		    putchar('\n');
		    state = OUT;
	       }
	       else
		    putchar(c);
	  }
     }

     return 0;
}
